
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>MASK RCNN+ Seeded watershed &#8212; seg_compare 0.0.1 documentation</title>
    <link rel="stylesheet" href="../_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script src="../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="nav-item nav-item-0"><a href="../index.html">seg_compare 0.0.1 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">MASK RCNN+ Seeded watershed</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="mask-rcnn-seeded-watershed">
<h1>MASK RCNN+ Seeded watershed<a class="headerlink" href="#mask-rcnn-seeded-watershed" title="Permalink to this headline">¶</a></h1>
<ul class="simple">
<li><p><b>Original repository</b>:   <a href="https://github.com/matterport/Mask_RCNN">  https://github.com/matterport/Mask_RCNN </a></p></li>
<li><p><b>License </b> : MIT License</p></li>
<li><p><b>Paper citation </b> : <i>He K, Gkioxari G, Dollar P, Girshick R. Mask R-CNN. IEEE International Conference on Computer Vision (ICCV). IEEE; 2017. pp. 2980–2988. doi:10.1109/ICCV.2017.322 </i></p></li>
<li><p><b>Concept</b>:  It uses a Mask-R CNN architecture combined with watershed based post processing. The MaskRCNN predicts ROIs in 2D test images (Z slices of confocal stacks)which are used to produce a 3D binary seed image for final watershed based post-processing.</p></li>
</ul>
<div align="center">
<img src="../_static/mrcnn_pipeline.png" alt="Unet_ws pipeline" width="1000" height="250"/>
<figcaption>Schematic diagram of the MaskRCNN+Watershed pipeline</figcaption>
</div>
<div class="section" id="installation">
<h2>Installation<a class="headerlink" href="#installation" title="Permalink to this headline">¶</a></h2>
<ol>
<li><p>Open a terminal and clone the MaskRCNN repository at <a href="https://github.com/matterport/Mask_RC">  https://github.com/matterport/Mask_RC </a> using:</p>
<p><code class="docutils literal notranslate"><span class="pre">git</span> <span class="pre">clone</span> <span class="pre">https://github.com/matterport/Mask_RCNN.git</span></code></p>
</li>
<li><p>Navigate to the Mask_RCNN folder and download the <a href="https://gitlab.inria.fr/mosaic/publications/seg_compare/-/tree/master/envs/mrcnn_env.yaml">  mrcnn_env.yaml </a> file (<b>envs/</b> in the <a href="https://gitlab.inria.fr/mosaic/publications/seg_compare">  GitLab</a>) inside the folder.</p></li>
<li><p>Make sure you are in the Mask_RCNN folder and create a new environment:</p>
<p><code class="docutils literal notranslate"><span class="pre">conda</span> <span class="pre">env</span> <span class="pre">create</span> <span class="pre">-f</span> <span class="pre">mrcnn_env.yaml</span></code></p>
</li>
</ol>
</div>
<div class="section" id="uses">
<h2>Uses<a class="headerlink" href="#uses" title="Permalink to this headline">¶</a></h2>
<p>The segmentation of an image using Cellpose method requires a trained model. This model can be obtained in two different ways:</p>
<ul class="simple">
<li><p>Download one of the proposed <a href="https://doi.org/10.6084/m9.figshare.14433590.v1">  trained models </a></p></li>
<li><p>Train your own model using either your data or the proposed <a href="https://www.repository.cam.ac.uk/handle/1810/262530 "> training data  </a> (see <a class="reference internal" href="dataset.html"><span class="doc std std-doc">Datasets</span></a>).</p></li>
</ul>
<p><b>Train your own model</b></p>
<ul>
<li><p><b>Data preparation</b>: MRCNN takes in 2D images and instance masks for each object to be segmented within an image. For this image Z slices from the training dataset of confocal images are used and instance masks are created from the corresponding ground truth images. An example training dataset is provided below.</p></li>
<li><p><b>Training environment</b>: Follow instructions under “Installation” for installing the MaskRCNN training environment. Invoke the MRCNN training environment using :</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>             `conda activate mrcnn_watershed`. 
</pre></div>
</div>
</li>
<li><p><b>Model training</b>: The MaskRCNN training can done by running the notebook <b>MRCNN_training.ipynb</b></p></li>
</ul>
<p><b>Use a model</b></p>
<ul class="simple">
<li><p><b>Post-processing</b>: The trained model can be used for predictions using the inference section of the <b>MRCNN_ training.ipynb</b>. The output of the prediction is a CSV file containing RLE coded regions detected by the MRCNN. For getting the seed image , use this csv file and the notebook <b>MRCNN_create_seed.ipynb</b>. For final 3D segmented output, use the <b>MRCNN_watershed_postprocessing.ipynb</b>. Links to notebooks are in the Downloads folder.</p></li>
</ul>
</div>
<div class="section" id="results">
<h2>Results<a class="headerlink" href="#results" title="Permalink to this headline">¶</a></h2>
<p>You can find sample segmentation results and ground truth at this <a href="https://doi.org/10.6084/m9.figshare.14447079.v1">  link </a>.</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">MASK RCNN+ Seeded watershed</a><ul>
<li><a class="reference internal" href="#installation">Installation</a></li>
<li><a class="reference internal" href="#uses">Uses</a></li>
<li><a class="reference internal" href="#results">Results</a></li>
</ul>
</li>
</ul>

  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/descriptions/mrcnn.md.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="nav-item nav-item-0"><a href="../index.html">seg_compare 0.0.1 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">MASK RCNN+ Seeded watershed</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Anuradha Kar.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 3.2.1.
    </div>
  </body>
</html>